/*
 * Subverse
 * Copyright (C) 2007 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include "Avatar.h"
#include "World.h"
#include "Utils.h"

Avatar::Avatar(World* w) :
	Element(w, "avatar", AVATAR)
{
    setCreature(true);
	setWorking(false);
	setMaxTime(6);
}

void Avatar::execute() {
	if (key[KEY_UP]) move(UP);
	else if (key[KEY_DOWN]) move(DOWN); 
	else if (key[KEY_RIGHT]) move(RIGHT);
	else if (key[KEY_LEFT]) move(LEFT);
	else if (key[KEY_LCONTROL]) {
		Element* e = getAround(ELEMENT, FRONT);
		if (e != NULL) attack(e);
	} else if (key[KEY_ALT]) {
        Element* e = getAround(ELEMENT, FRONT);
		if (e != NULL) eat(e);
    }
}

Avatar::~Avatar() {
}
