/*
 * Subverse
 * Copyright (C) 2007 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include "Cyclope.h"
#include "World.h"
#include <stdlib.h>

Cyclope::Cyclope(World* w) :
	Element(w, "cyclope", CYCLOPE)
{
    setCreature(true);
}

void Cyclope::execute() {
	bool found = false;
	Vision *vision = getVision();
	Element* e =  NULL;
	// Procura por um objetivo
	do {
        e = vision->getNext(ELEMENT);
		if (e != NULL) {
            if (getHelth() < 20) {
                if ((e->getType() == TREE) && (e->getFood() > 0)) {
                    found = true;
                } else if ((e->isCreature()) && (!e->isAlive()) && (e->getFood() > 0)) {
                	found = true;
                }
            } else if (isUnderAttack() && (e == getAttacker()) && e->isAlive()) {
            	found = true;
			} else if ((e->getType() == AVATAR) && e->isCreature() && e->isAlive()) {
				found = true;
            }
		}
    } while ((!found) && (e != NULL));
    
	if (found) {
		Element* front = getAround(ELEMENT, FRONT);
		// Ainda esta dando problemas, nao sei por que
		//if (front == NULL) front = getAround(ELEMENT, FRONT_LEFT);
		//if (front == NULL) front = getAround(ELEMENT, FRONT_RIGHT);

		if ((front != NULL) && (e == front)) {
            if ((e->getType() != CYCLOPE) && (e->isCreature())) {
            	attack(e);
            } else if ((e->getType() == TREE) && (e->getFood() > 0)) {
                eat(e);
            } else if ((e->isCreature()) && (!e->isAlive()) && (e->getFood() > 0)) {
            	eat(e);
            } else move((rand() % 4) * 2);
        } else {
			if (e->getX() > getX()) move(RIGHT);
			else if (e->getX() < getX()) move(LEFT);
			else if (e->getY() > getY()) move(DOWN);
			else if (e->getY() < getY()) move(UP);
        }
    } else {
    	// Se nao tem objetivo, anda aleatoriamente
        move((rand() % 4) * 2);
    }
}

Cyclope::~Cyclope() {
}
