/*
 * Subverse
 * Copyright (C) 2007 Saulo Popov Zambiasi
 *
 * Subverse is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * Subverse is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Contact: saulopz@gmail.com
 */

#include "Images.h"

Images::Images() {
	BITMAP *bmp = create_bitmap(CELL_SIZE, CELL_SIZE);
	clear_to_color(bmp, makecol(255, 0, 255));
	line(bmp, 0, 0, bmp->w, bmp->h, makecol(255, 255, 255));
	line(bmp, 0, bmp->h, bmp->w, 0, makecol(255, 255, 255));
	bitmaps["void"] = bmp;
}

void Images::add(string imageName) {
	string temp = "";
	string temp2 = "";
	for (unsigned int i = 0; i < 16; i++) {
		temp = IMAGES_DIR;
		temp += "//" + imageName + intToString(i) + ".bmp";
		BITMAP *bmp = load_bitmap(temp.c_str(), NULL);
		if (!bmp) bmp = NULL;
		
		temp = imageName + intToString(i);
		bitmaps[temp] = bmp;
		
		if (bmp == NULL)  {
			switch (i) {
                case 8 :
                case 10:
				case 1 : temp2 = imageName + "0"; break;
				case 2 : temp2 = imageName + "0"; break;
				case 9 :
                case 11:
				case 3 : temp2 = imageName + "1"; break;
				case 4 : temp2 = imageName + "0"; break;
				case 5 : temp2 = imageName + "1"; break;
				case 6 : temp2 = imageName + "2"; break;
				case 7 : temp2 = imageName + "3"; break;
				case 12:
                case 14: temp2 = imageName + "4"; break;
                case 13:
                case 15: temp2 = imageName + "5"; break;
				default : temp2 = "void";
			}
			bitmaps[temp] = bitmaps[temp2];
		}
	}
}

BITMAP* Images::get(std::string fileName) {
	return bitmaps[fileName];
}

Images::~Images() {
}
